// *** basics ***
#version 3.1;

// *** standard includes ***
#include "colors.inc"
#include "textures.inc"
#include "woods.inc"
#include "stones.inc"
#include "skies.inc"

// *** custom includes ***
#include "i_textur.inc"

// *** control variables ***
#declare trace_area=1;
#declare trace_bonsai_i=1;
#declare trace_bonsai_d=1;
#declare trace_panels=1;
#declare trace_pot_i=1;
#declare trace_pot_d=1;
#declare trace_tab=1;
#declare trace_floor=1;


// *** oriental panels ***
#if (trace_panels)
#declare wide_wood=
superellipsoid{
 <.1,.1>
 rotate 90*x
 scale <3,125,1>
 texture{
  T_Wood4
//  pigment{Gray10}
  normal{wood}
  finish{Phong_Shiny}
  rotate 90*x
  scale 10
 }
}
#declare tiny_wood=
superellipsoid{
 <.1,.1>
 rotate 90*x
 scale <1,125,1>
 texture{
  T_Wood4
//  pigment{Gray10}
  normal{wood}
  finish{Phong_Shiny}
  rotate 90*x
  scale 10
 }
}
#declare panel=
union{
 box{
  <-125,-125,-.1>
  < 125,125, .1>
  texture{pigment{White}}
  translate .5*z
 }
 object{wide_wood translate -125*x}
 object{wide_wood translate 125*x}
 object{wide_wood rotate 90*z translate 125*y}
 object{wide_wood rotate 90*z translate -125*y}
 object{tiny_wood translate -100*x}
 object{tiny_wood translate -75*x}
 object{tiny_wood translate -50*x}
 object{tiny_wood translate -25*x}
 object{tiny_wood }
 object{tiny_wood translate 100*x}
 object{tiny_wood translate 75*x}
 object{tiny_wood translate 50*x}
 object{tiny_wood translate 25*x}
 object{tiny_wood rotate 90*z translate -75*y}
 object{tiny_wood rotate 90*z translate -25*y}
 object{tiny_wood rotate 90*z translate 75*y}
 object{tiny_wood rotate 90*z translate 25*y}
}
object{panel translate <0,128.5,250>}
object{panel translate <256,128.5,250>}
object{panel rotate 90*y translate <-125,128.5,125>}
object{panel rotate 90*y translate <124,128.5,83>}
object{panel rotate 90*y translate <-125,128.5,-125>}
object{panel rotate 90*y translate <125,128.5,-125>}
object{panel translate <0,128.5,-250>}
plane{y,251 pigment{White}}
sky_sphere{S_Cloud2}
 plane{z,255 pigment{White}}
#else
 plane{z,250 pigment{White}}
#end


// *** esterilla floor ***
#if (trace_floor)
#declare r_ester=seed(64);
#declare num_cyl=600;
#declare cnt_cyl=1;
#declare esterilla=
union{
#while (cnt_cyl<=num_cyl)
 cylinder{<0,0,-250>,<0,0,250>,.4
  texture{T_Wood7
   finish{Shiny reflection .05}
   scale 500 translate rand(r_ester)*1000
  }
  translate ((-num_cyl*.5*.8)+cnt_cyl*.8)*x
 }
 #declare cnt_cyl=cnt_cyl+1;
#end
}
object{esterilla translate 100*x}
#end


// *** mesita izquierda***
#if (trace_tab)
#declare r_mesa=seed(36);
#declare t_tab_mad=
texture{T_Wood27 finish{Shiny reflection .1}}
union{
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <29,2,29>
  texture{t_tab_mad rotate 90*y scale 4}
  translate <0,31,0>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <26,2,26>
  texture{t_tab_mad rotate 90*y scale 4 translate 100*rand(r_mesa)}
  translate <0,27,0>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <2,13,2>
  texture{t_tab_mad rotate 90*x scale 4 translate 100*rand(r_mesa)}
  translate <-23,13,23>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <2,13,2>
  texture{t_tab_mad rotate 90*x scale 4 translate 100*rand(r_mesa)}
  translate <-23,13,-23>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <2,13,2>
  texture{t_tab_mad rotate 90*x scale 4 translate 100*rand(r_mesa)}
  translate <23,13,23>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <2,13,2>
  texture{t_tab_mad rotate 90*x scale 4 translate 100*rand(r_mesa)}
  translate <23,13,-23>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <24,1,1>
  texture{t_tab_mad rotate 90*y scale 4 translate 100*rand(r_mesa)}
  translate <0,16,23.5>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <24,1,1>
  texture{t_tab_mad rotate 90*y scale 4 translate 100*rand(r_mesa)}
  translate <0,16,-23.5>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <1,1,24>
  texture{t_tab_mad scale 4 translate 100*rand(r_mesa)}
  translate <23.5,16,0>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <1,1,24>
  texture{t_tab_mad scale 4 translate 100*rand(r_mesa)}
  translate <-23.5,16,0>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <1,5,1>
  texture{t_tab_mad rotate 90*x scale 4 translate 100*rand(r_mesa)}
  translate <0,20,-23.5>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <1,5,1>
  texture{t_tab_mad rotate 90*x scale 4 translate 100*rand(r_mesa)}
  translate <-4,20,-23.5>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <1,5,1>
  texture{t_tab_mad rotate 90*x scale 4 translate 100*rand(r_mesa)}
  translate <4,20,-23.5>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <1,5,1>
  texture{t_tab_mad rotate 90*x scale 4 translate 100*rand(r_mesa)}
  translate <0,20,23.5>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <1,5,1>
  texture{t_tab_mad rotate 90*x scale 4 translate 100*rand(r_mesa)}
  translate <-4,20,23.5>
 }
 superellipsoid{
  <.1,.1>
  rotate 90*x
  scale <1,5,1>
  texture{t_tab_mad rotate 90*x scale 4 translate 100*rand(r_mesa)}
  translate <4,20,23.5>
 }
 translate <-22,0,205>
}
#end


// *** maceta izquierda ***
#if (trace_pot_i)
union{
 union{
  intersection{
   difference{
    cylinder{<0,-8,0>,<0,8,0>,20}
    torus{20,8}
   }
   plane{y,0 inverse}
   plane{y,5.5 }
   scale 2
   translate 1.9*y
  }
  torus{24,1 translate 1*y}
  torus{28,1 translate 14*y}
  texture{
   pigment{NavyBlue*.2+SeaGreen*.2}
   normal{bumps .1 scale <1,2,1>}
   finish{Phong_Shiny reflection .1}
  }
 }
 height_field{
  png "hf_terr"
  water_level 0.1
  translate -.5
  scale <46,10,46>
  texture{grass_texture scale .1}
  translate 18*y
 }
 scale <.9,1,.9>
 translate <-22,33.5,205>
}
#end

// *** maceta derecha ***
#if (trace_pot_d)
union{
 union{
  intersection{
   union{
    torus{20,8 translate 8*y}
    torus{25,1 translate 1*y}
    torus{24,1 translate 16*y}
   }
   plane{y,9}
  }
  torus{28,1 translate 9*y}
  texture{
   pigment{DarkTan*.5+Firebrick*.5}
   normal{dents .1 scale <1,2,1>}
   finish{Phong_Glossy}
  }
 }
 height_field{
  png "hf_terr"
  water_level 0.1
  translate -.5
  rotate 90*y
  scale <54,10,54>
  texture{grass_texture scale .2 translate 100}
  translate 13*y
 }
 translate <60,.5,205>
}
#end


// *** bonsai izquierda ***
#if (trace_bonsai_i)
#include "treemacr.inc"
#declare base_radius         =8;
#declare top_radius          =1;
#declare sections            =32;
#declare start_section_lenght=10;
#declare end_section_lenght  =5;
#declare branch_start_section=12;
#declare verticality         =.9;
#declare curves              =.9;
#declare startbranch_sections=32;
#declare branch_v_min_angle  =60;
#declare branch_v_max_angle  =80;
#declare branch_h_rotation   =60;
#declare sbranch_v_min_angle =30;
#declare sbranch_v_max_angle =60;
#declare sbranch_h_rotation  =0;
#declare fbranch_v_min_angle =20;
#declare fbranch_v_max_angle =30;
#declare fbranch_h_rotation  =90;
#declare branchs_per_section =1;
#declare branch_percentage   =.3;
#declare sbranch_percentage  =.3;
#declare lbranch_percentage  =.6;
#declare leaves_percentage  =.9;
#declare number_of_roots     =6;
#declare bark_texture        =texture{t_bark}
#declare l_switch            =on;
#declare i_leaves="i_leaves.inc"
#declare random_seed         =6973;
#declare bonsai_izq=
#include "tree.inc"
object{bonsai_izq scale .4 rotate 90*y translate <-22,54,205>}
#end


// *** bonsai derecha ***
#if (trace_bonsai_d)
#include "treemacr.inc"
#declare base_radius         =9;
#declare top_radius          =1;
#declare sections            =40;
#declare start_section_lenght=12;
#declare end_section_lenght  =6;
#declare branch_start_section=6;
#declare verticality         =.9;
#declare curves              =.9;
#declare startbranch_sections=32;
#declare branch_v_min_angle  =10;
#declare branch_v_max_angle  =20;
#declare branch_h_rotation   =180;
#declare sbranch_v_min_angle =10;
#declare sbranch_v_max_angle =20;
#declare sbranch_h_rotation  =90;
#declare fbranch_v_min_angle =10;
#declare fbranch_v_max_angle =20;
#declare fbranch_h_rotation  =90;
#declare branchs_per_section =1;
#declare branch_percentage   =.3;
#declare sbranch_percentage  =.3;
#declare lbranch_percentage  =.6;
#declare leaves_percentage  =.6;
#declare number_of_roots     =6;
#declare bark_texture        =texture{t_bark2}
#declare t_leaves      =texture{t_leaves2}
#declare i_leaves="i_leaves2.inc"
#declare l_switch            =on;
#declare random_seed         =8574;
#declare bonsai_dcha=
#include "tree.inc"
object{bonsai_dcha scale .4 rotate 90*y translate <62,14,205>}
#end


// *** lights ***
light_source{
 <-110,240,200>
 White*.5+Gold*.5
 #if (trace_area=1)
  area_light
  <18,0,0> <0,0,18>
  9, 9
  adaptive 1
  jitter
 #end
 fade_distance 250
 fade_power 2
}
light_source{
 <110,240,230>
 White*.5+Gold*.5
 #if (trace_area=1)
  area_light
  <18,0,0> <0,0,18>
  9, 9
  adaptive 1
  jitter
 #end
 fade_distance 250
 fade_power 2
}
light_source{
 <110,240,0>
 White*.5+Gold*.5
 #if (trace_area=1)
  area_light
  <9,0,0> <0,0,9>
  4, 4
  adaptive 1
  jitter
 #end
 fade_distance 250
 fade_power 2
}
light_source{
 <-110,240,0>
 White*.5+Gold*.5
 #if (trace_area=1)
  area_light
  <9,0,0> <0,0,9>
  4, 4
  adaptive 1
  jitter
 #end
 fade_distance 250
 fade_power 2
}

// *** and take the shot! ***
camera{
  location <-6,70,-200>
  direction 2.5*z
  look_at <1,68,200>
  translate 30*x
}
/*
light_source{
 <-6,70,-200>
 White*.75*.1+Gold*.5*.1
 translate 30*x
}
*/
